#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	libxmlb
Version		:	0.3.19
Release		:	17.0.10.rel%{?dist}
Summary		:	Library for querying compressed XML metadata

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	LGPL-2.1
URL		:	https://github.com/hughsie/%{name}

Source0		:	%{name}-%{version}.tar.xz

#-----------------------------------------------------------------------------
BuildRequires	:	glib-devel
BuildRequires	:	libstemmer-devel
BuildRequires	:	python3-libstemmer
BuildRequires	:	shared-mime-info
BuildRequires	:	xz-devel
BuildRequires	:	zstd-devel
#-----------------------------------------------------------------------------
%description
XML is slow to parse and strings inside the document
cannot be memory mapped as they do not have a trailing
NUL char. The libxmlb library takes XML source, and
converts it to a structured binary representation with
a deduplicated string table -- where the strings have
the NULs included.
 
This allows an application to mmap the binary XML file,
do an XPath query and return some strings without
actually parsing the entire document. This is all done
using (almost) zero allocations and no actual copying
of the binary data.

#-----------------------------------------------------------------------------
%files
%defattr(-,root,root,-)
%doc README.md
%license LICENSE
%{_bindir}/xb-tool
%{_libdir}/girepository-1.0/Xmlb-2.0.typelib
%{_libdir}/%{name}.so.2*
%{_mandir}/man1/xb-tool.1.gz

#=============================================================================
%package		devel
Summary		:	Development package for %{name}

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
Files for development with %{name}.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{name}-2/xmlb.h
%{_includedir}/%{name}-2/%{name}/*.h
%{_libdir}/%{name}.so
%{_libdir}/pkgconfig/xmlb.pc
%{_datadir}/gir-1.0/Xmlb-2.0.gir
%{_datadir}/gtk-doc/html/%{name}/*.html
%{_datadir}/gtk-doc/html/%{name}/*.png
%{_datadir}/gtk-doc/html/%{name}/style.css

#=============================================================================
%package		tests
Summary		:	Files for installed tests

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		tests
Executable and data files for installed tests.

#-----------------------------------------------------------------------------
%files			tests
%defattr(-,root,root,-)
%doc README.md
%{_libexecdir}/installed-tests/%{name}/xb-self-test
%{_libexecdir}/installed-tests/libxmlb/test.*
%{_datadir}/installed-tests/%{name}/%{name}.test

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

meson						\
	--prefix=%{_prefix}			\
        --includedir=%{_includedir}		\
	--libexecdir=%{_libexecdir}		\
        --sysconfdir=%{_sysconfdir}		\
        --sbindir=%{_sbindir}			\
	--mandir=%{_mandir}			\
	-D gtkdoc=true				\
	-D tests=true				\
	-D stemmer=true				\
	_build					\


meson						\
	test					\
	-C _build

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#testing program
%check
meson						\
	test					\
	-C _build				\
	--print-errorlogs

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot}				\
	meson					\
		install				\
		-C _build			\

#-----------------------------------------------------------------------------
%changelog
